#define DLL_EXPORT   

#ifndef _DLL_TUTORIAL_H_
    #define _DLL_TUTORIAL_H_
    #include <iostream>
     
    #if defined DLL_EXPORT
      #define DECLDIR __declspec(dllexport)
    #else
      #define DECLDIR __declspec(dllimport)
    #endif
     
     
  struct HwId
  {
    CString VendorID;
    CString ProductID;
    bool    IdSet;
    HwId()  { IdSet = false; VendorID.Empty(); ProductID.Empty(); }
  };

  struct PortDetails
  {
    CString PortName;
    CString DevDesc;
    HwId    HardwareID;
    PortDetails() { PortName.Empty(); DevDesc.Empty(); }
  };
  typedef CArray<PortDetails> PortList;

  PortList  m_ComsPorts;
  
     
    extern "C"
    {
        DECLDIR unsigned char RA2_GetAPI();
        DECLDIR unsigned char RA2_HomeAll();
        DECLDIR unsigned char RA2_HomeAxis(unsigned char Axis);
        DECLDIR void RA2_GetPosition(unsigned int* A, unsigned int* B, unsigned int* C);
        DECLDIR void RA2_SetRelay(unsigned char State);
        DECLDIR void RA2_StorePosition(unsigned char Index);
        DECLDIR void RA2_StoreCoords(unsigned char Index, unsigned int A, unsigned int B, unsigned int C);
        DECLDIR void RA2_GotoPosition(unsigned char Index);
        DECLDIR void RA2_SetMotor(unsigned char Motor, unsigned int Position);
        DECLDIR void RA2_SetMotors(unsigned int A, unsigned int B, unsigned int C);
        DECLDIR unsigned char RA2_IsMoving();
        DECLDIR void RA2_GetXYZ(signed int* X, signed int* Y, signed int* Z);
        DECLDIR void RA2_SetXYZ(signed int X, signed int Y, signed int Z);
        DECLDIR void RA2_SetGripper(unsigned char Position);
        DECLDIR void RA2_GetColour(unsigned char* R, unsigned char* G, unsigned char* B);
        DECLDIR void RA2_SetMoveSpeed(unsigned int Speed, unsigned int Increment);
        DECLDIR void RA2_DisableMotors();
        DECLDIR void RA2_WriteLED(unsigned char LED, unsigned char State);
        DECLDIR void RA2_RestoreAutoLEDs();

        DECLDIR unsigned char RA2_ComFindFirst(void);
        DECLDIR unsigned char RA2_ComQuery(unsigned char Port);

        DECLDIR unsigned char RA2_ComOpen(unsigned char Port);
        DECLDIR void RA2_SetPort(unsigned char Port);
        DECLDIR unsigned char RA2_ComClose(unsigned char Port);
        DECLDIR void BaudRateSet(unsigned char Port, unsigned long Baud);
        DECLDIR unsigned int ReadCharCOM(unsigned char Port, unsigned int timeout, unsigned int timeout_val);
        DECLDIR void SendCharCOM(unsigned char Port, unsigned char Data);
        DECLDIR void SetDTRStatePrivate(unsigned char Port, unsigned char state);
        DECLDIR void SetFlowControlPrivate(unsigned char Port, unsigned char state);
    }
     
 #endif
 
 